\newpage

Déploiement d'un service via Ansible
====================================

Très bien ! vous semblez avoir compris le fonctionnement de notre
gestionnaire de configuration.

Après cet échauffement, vous devriez être prêt à créer un *playbook*
dédié à l'installation d'un serveur [Matrix](https://matrix.org/) :

![Riot](riot.png "Riot : un des clients utilisable pour joindre son serveur Matrix")


Vous connaissez et utilisez sans doute Slack, un service de messagerie
instantannée qui a supplanté IRC, Jabber, ... Il vient avec le gros
inconvénient qu'il est centralisé, qu'il ne permet pas de faire discuter des
personnes qui, bien qu'utilisant le même service, ne sont pas dans le même
groupe ; mais surtout, il vient avec aucun élément de sécurité : il n'est en
effet pas possible d'avoir de chiffrement de bout-en-bout, entre deux personnes
ou un groupe, et les administrateurs des groupes, tout comme le gouvernement
américian, ont accès à tout l'historique. Vous l'aurez compris, Matrix est donc
une solution de messagerie décentralisée et permet de réaliser du chiffrement
de bout-en-bout.

Vous trouverez la documentation d'installation précise et détaillée à :
<https://github.com/matrix-org/synapse/blob/master/README.rst> (attention, une
release 1.0 est prévue pour dans peu de temps, pensez à vous fixer une version,
n'utilisez pas la branche master qui risque de ne plus fonctionner au moment du
moulinétage de votre rendu).

Vous devrez attacher une importance tout particulière à la sécurité de
la solution que vous déployez : configurations durcies, utilisateur
dédié lorsque c'est possible (pas de `root` !), droits d'accès et
permissions des répertoires, etc.

Profitez des [modules de base de
données](http://docs.ansible.com/ansible/latest/list_of_database_modules.html)
pour l'initialiser correctement. Et bien entendu de l'ensemble des
modules décrits dans la documentation standard !


## Configurations

Tous les éléments de configuration (mot de passes de connexion à la
base de données, chemins, etc.) sont à déclarer comme variables dans
le fichier `vars/matrix-config.yml`, que vous prendrez soin d'importer
dans votre *Playbook*.

Vous devrez générer un certificat TLS afin de joindre les autres serveurs.


## Backup

Vous ajouterez enfin une tâche hebdomadaire de sauvegarder de la base
de données. Le *dump* obtenu est à placer dans `/var/backups/`.


## Client de test

Vous n'êtes pas tenu d'installer un client. Pour vos tests, vous pouvez
utiliser <https://riot.im/app/>, en changeant l'adresse du serveur Matrix pour
votre sous-domaine dédié à Matrix (normalement
<https://matrix.login_x.srs.p0m.fr/>). (Conservez le serveur d'identité à
<https://vector.im>).



## Validation

Pour valider l'installation de votre serveur, rejoignez le canal
`#adlin:nemunai.re` et envoyez un message « Ping ! » à `@nemubot:nemunai.re`
qui s'occupera de valider ce pallier.

Vous devriez également pouvoir tester entre-vous.
