\newpage

Démarrer sur le SI du jour
==========================

Présentation du système d'information
-------------------------------------

Le système d'information que vous allez avoir à gérer aujourd'hui est
de taille moyenne : vous aurez en votre possession un résolveur DNS, un serveur
de base de données ainsi que deux serveurs web (servant respectivement
TinyTinyRSS que vous connaissez, ainsi que Mattermost, une plate-forme de chat,
alternative libre de Slack).

Vous êtes l'administrateur réseau de l'entreprise et l'on vous demande de
connecter tous ces services **correctement**.

L'image ISO que vous avez récupérée met à votre disposition tout ce système
d'information, déjà configuré pour sa partie logicielle, il ne reste plus qu'à
éditer la configuration du routeur.

![Architecture réseau à produire](topologie.png "Topologie")

Attention, contrairement au précédent TP, tout se fait en direct, il n'y a
aucune sauvegarde effectuée : à chaque redémarrage de la machine virtuelle,
vous retomberez dans l'état initial.

Accéder à la machine virtuelle
------------------------------

Une fois la machine virtuelle démarrée, vous devriez voir apparaître l'IP qu'à
obtenue la machine sur votre réseau :

```
    4: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP qlen 1000
        link/ether 42:2c:63:f1:5a:49 brd ff:ff:ff:ff:ff:ff
	    inet 10.42.23.211/24 brd 10.42.23.255 scope global eth0
            valid_lft forever preferred_lft forever
        inet6 fe80::4534:6558:22cf:f2cd/64 scope link
            valid_lft forever preferred_lft forever
    nsenter: cannot open /run/netns/wks1: No such file or directory
```

Cette IP est l'IP externe de votre routeur, qu'il a obtenu par DHCP.

Une ligne de commande est disponible au sein de la machine virtuelle à des fins
de débogage, si nécessaire. Vous ne devriez normalement pas avoir à interagir
avec celle-ci.

Si vous assignez deux cartes réseau à la machine virtuelle, vous devriez voir
apparaître l'IP de la carte `eth1` en dessous. Il s'agit d'une interface de
station de travail.


Objectif du TP
--------------

Toutes les IP notées sur le schéma ont déjà été configurées par votre
administrateur système en suivant vos instructions. Votre tâche est de rendre
accessible les services web sur internet ainsi qu'aux stations de
travails. Tout le monde doit avoir accès à internet et utiliser le serveur de
noms local (les serveurs ayant déjà été configurés ainsi, il faudra simplement
s'assurer que ce soit également le cas des stations de travail).

Étant donné le caractère éphémère de vos actions, la réalisation d'un
*Playbook* Ansible semble plutôt adapté !
